function [err] = plsa_classify_itkernels(td_train, labels_train, td_test, labels_test)

qq = 0:0.2:2;
nfold = 3;

D = prdataset(td_train', labels_train);
R = prcrossval(D, [], nfold, 0);

for c = 1:5
    for r=1:nfold
        
        data_train = D.data((R~=r), :);
        l_train = D.nlab(R~=r);
        data_test = D.data((R==r), :);
        l_test = D.nlab(R==r);
        
        C = 0.001*10^c;
        
        KKjs_inner = IT_Kernel(data_train, data_train, 1, 1);
        Kjs_tr_inner = KKjs_inner{1};
        [w, J] = libsvc(prdataset(Kjs_tr_inner, l_train), 0, C);
        KKjs_inner = IT_Kernel(data_test, data_train, 1, 1);
        Kjs_te_inner = KKjs_inner{1}(:, J);
        err_inner(r) = testc(prdataset(Kjs_te_inner, l_test), w);
    end
    
    E(c) = mean(err_inner);
    
end

[val, bestC] = min(E);
bestC = 0.001*10^bestC; 

%  Shannon-Jensen divergence kernel
KKjs = IT_Kernel(td_train', td_train', 1, 1);
Kjs_tr = KKjs{1};
[w, J] = libsvc(prdataset(Kjs_tr, labels_train), 0, bestC);
KKjs = IT_Kernel(td_test', td_train', 1, 1);
Kjs_te = KKjs{1}(:, J);
err(1) = testc(prdataset(Kjs_te, labels_test), w);

%  Jensen-Tsallis kernel
KKjt_tr = IT_Kernel(td_train', td_train', 2, qq);
KKjt_te = IT_Kernel(td_test', td_train', 2, qq);
for k=1:length(qq)
    [w, J] = libsvc(prdataset(KKjt_tr{k}, labels_train), 0, bestC);
    Kjt_te{k} = KKjt_te{k}(:,J);
    tmp(k) = testc(prdataset(Kjt_te{k}, labels_test), w);
end
err(2) = min(tmp);

%  Weighted Jensen-Tsallis kernel
KKwjt_tr = IT_Kernel(td_train', td_train', 3, qq);
KKwjt_te = IT_Kernel(td_test', td_train', 3, qq);
for k=1:length(qq)
    [w, J] = libsvc(prdataset(KKwjt_tr{k}, labels_train), 0, bestC);
    Kwjt_te{k} = KKwjt_te{k}(:,J);
    tmp(k) = testc(prdataset(Kwjt_te{k}, labels_test), w);
end
err(3) = min(tmp);

%  Linear kernel
tr = prdataset(td_train', labels_train);
te = prdataset(td_test', labels_test);
KKlin_tr = tr*proxm(tr,'p',1);
KKlin_te = te*proxm(tr,'p',1);
[w, J] = libsvc(KKlin_tr, 0, bestC);
Klin_te = KKlin_te.data(:,J);
err(4) = testc(prdataset(Klin_te, labels_test), w);

